#!/usr/bin/perl

use FileHandle;

#
# 600 was decreased because we are calculating ten minutes's data.
#
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time-86400);
$mon++;
$min=$min-$min%10;
$nyear=$year+1900;

##############################################################################
#
# Modify the following to meet your configuration.
#

#
# $dir is where you put your program and config files
# $rawdir is where the raw log files kept
# $outputdir is where the output files should be
#

$dir       = "/home/flow-tools/analysis";
$tmpdir    = "/home/flow-tools/dailytmp";
$rawdir    = "/home/flow-tools/logs";
$subrawdir = sprintf ("%4.4d-%2.2d-%2.2d", $nyear, $mon, $mday);
$flowreport = "/home/flow-tools/bin/flow-report";
$reportcfg = "/home/flow-tools/etc/daily-check-report.cfg";
$flowcat = "/home/flow-tools/bin/flow-cat";
$outputdir = "/home/flow-tools/html/daily";
$httpdir   = sprintf ("html/%4.4d%2.2d%2.2d", $nyear, $mon, $mday);
$htmldir   = sprintf ("%s/html/%4.4d%2.2d%2.2d", $outputdir, $nyear, $mon, $mday);
$nfile = sprintf ("ft-v05.%4.4d-%2.2d-%2.2d.%2.2d%2.2d*", $nyear, $mon, $mday, $hour, $min);
$TopN      = 200;

# flow-report to /home/flow-tools/tmp
system("rm -f $tmpdir/*");
system("$flowcat $rawdir/$subrawdir/ft* | $flowreport -s$reportcfg -Sdailycheck");


#
# require getschoolbyip function
#
require "$dir/getschoolbyip.pl";

#
# RAW File processing finished.
# Begin generating daily output diagrams.
#

mkdir $htmldir,0755;

#
# Call subroutines to perform the output format.
#

&topn_src_ip;

##############################################################################
#
# subroutines begin here:
#
##############################################################################

#
# list top N for check virus
#
sub topn_src_ip {
   my($type);
   topn_src_ip_html("CodeRed","codered");
   topn_src_ip_html("Nimda","nimda");
   topn_src_ip_html("MailVirus","smtp");
   foreach $type ("DCOM_RPC","slapper","slappers","dp1434","dp445"){
      topn_src_ip_html($type,$type);
   }
}

sub topn_src_ip_html {
   my($type, $logfile) = @_;
   my($file) = sprintf ("%s/Daily-%s.html", $htmldir, $type);
   my $fhin = new FileHandle("$tmpdir/$logfile-in.report");
   my $fhout = new FileHandle("$tmpdir/$logfile-out.report");

   my (@linein,@lineout) = ((),());
   chomp($line = <$fhin>); 
   chomp($line = <$fhout>);
   chomp(@linein = <$fhin>);
   chomp(@lineout = <$fhout>);
   $numin=scalar(@linein);
   $numout=scalar(@lineout);

   if ( $numin > $numout ) {
      $maxnum = $numin;
   } else {
      $maxnum = $numout;
   }

   if ( $TopN < $maxnum ) {
      $maxnum = $TopN;
   }

   open FILE, ">$file" or die $!;
   printf FILE ("<html>\n<body bgcolor=\"#ffffff\">\n");
   printf FILE ("<title>%4.4d-%2.2d-%2.2d %2.2d:%2.2d Daily Like%s Statistics </title>\n", $nyear, $mon, $mday, $hour, $min, $type);
   print FILE "<center>\n";
   printf FILE ("%4.4d-%2.2d-%2.2d %2.2d:%2.2d Daily Like %s Statistics <a href=\"../%s-doc.html\" target=\"_blank\">  </a>\n", $nyear, $mon, $mday, $hour, $min, $type, $type);
   printf FILE ("<br>\n");

   print FILE "<table>\n";
   print FILE "<table border=2 width=90%>\n";
   print FILE "<tr bgcolor=lightgreen><td align=right>~D</td><td align=right>Flows</td><td align=right>Packets</td><td align=right>Bytes</td><td align=right>Ǯ</td><td align=right>IP</td><td align=right>Flows</td><td align=right>Packets</td><td align=right>Bytes</td></tr>\n";

   for ($i=0; $i<$maxnum; $i++) {
      my($ipin,$flowin,$sizein,$pktsin,$durin) = split (m"\,", $linein[$i]);
      my($ipout,$flowout,$sizeout,$pktsout,$durout) = split (m"\,", $lineout[$i]);
      printf FILE ("<tr><td align=right>%15s</td><td align=right>%11d</td><td align=right>%11.1f</td><td align=right>%11.1f</td><td align=right>%15s</td><td align=right>%15s</td><td align=right>%11d</td><td align=right>%11.1f</td><td align=right>%11.1f</td></tr>\n",$ipout,$flowout,$pktsout,$sizeout,getschoolbyip($ipin),$ipin,$flowin,$pktsin,$sizein);
   }
   print FILE "</table>\n";
   close FILE;

# make the index.html
   my($file) = sprintf ("%s/html/Daily-%s.html", $outputdir, $type);
   open FILE, ">$file" or die $!;
   print FILE "<html><head>";
   print FILE "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=big5\">\n";
   print FILE "<meta http-equiv=\"Expires\" content=\"Mon, 26 Jul 1997 05:00:00 GMT\">\n";
   print FILE "<meta http-equiv=\"Last-Modified\" content=\"Mon, 25 Feb 2002 00:05:00 GMT\">\n";
   print FILE "<meta http-equiv=\"Cache-Control\" content=\"no-cache, must-revalidate\">\n";
   print FILE "<meta http-equiv=\"Pragma\" content=\"no-cache\">\n";
#   printf FILE ("<META HTTP-EQUIV=REFRESH CONTENT=\"0;URL=http://netflow.kh.edu.tw/netflow/daily/%s/%s-%s-%s.html\">\n", $httpdir, $type, $hour, $min);
   printf FILE ("<META HTTP-EQUIV=REFRESH CONTENT=\"0;URL=%4.4d%2.2d%2.2d/Daily-%s.html\">\n", $nyear, $mon, $mday , $type, );
   printf FILE ("<title>%s</title>\n", $type);
   printf FILE ("</head>\n<body>Loading......</body>\n</html>\n");
   close FILE;

#
# notify admin if need
#
#   my($ipin,$flowin,$sizein,$pktsin,$durin) = split (m"\,", $linein[0]);
#   my($ipout,$flowout,$sizeout,$pktsout,$durout) = split (m"\,", $lineout[0]);

#if ( $flowin >= 1000 || $flowou >= 1000 ) {
#   system ("mail -s $type kiec-net\@mail.kh.edu.tw < $file");
#   }
#else {
#}

#   system("/usr/bin/gzip $file");

}
