#!/usr/bin/perl

use FileHandle;

#
# 600 was decreased because we are calculating ten minutes's data.
#
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time-86400);
$mon++;
$min=$min-$min%10;
$nyear=$year+1900;

##############################################################################
#
# Modify the following to meet your configuration.
#

#
# $dir is where you put your program and config files
# $rawdir is where the raw log files kept
# $outputdir is where the output files should be
#

$dir       = "/home/flow-tools/analysis";
$tmpdir    = "/home/flow-tools/dailytmp";
$rawdir    = "/home/flow-tools/logs";
$subrawdir = sprintf ("%4.4d-%2.2d-%2.2d", $nyear, $mon, $mday);
$flowreport = "/home/flow-tools/bin/flow-report";
$reportcfg = "/home/flow-tools/etc/daily-report.cfg";
$flowcat = "/home/flow-tools/bin/flow-cat";
$outputdir = "/home/flow-tools/html/daily";
$httpdir   = sprintf ("html/%4.4d%2.2d%2.2d", $nyear, $mon, $mday);
$htmldir   = sprintf ("%s/html/%4.4d%2.2d%2.2d", $outputdir, $nyear, $mon, $mday);
$nfile = sprintf ("ft-v05.%4.4d-%2.2d-%2.2d.%2.2d%2.2d*", $nyear, $mon, $mday, $hour, $min);
$textdir = sprintf ("%s/text/%4.4d%2.2d%2.2d", $outputdir, $nyear, $mon, $mday);
$TopN      = 100;

# flow-report to /home/flow-tools/tmp
system("rm -f $tmpdir/*");
system("$flowcat $rawdir/$subrawdir/ft* | $flowreport -s$reportcfg -Sdaily");

# RAW File processing finished.
# Begin generating daily output diagrams.
mkdir $htmldir,0755;
mkdir $textdir,0755;

# require getschoolbyip function
require "$dir/getschoolbyip.pl";

# Call subroutines to perform the output format.
&htmloutput; # XUتAȲέp
&sumoutput;  # XiXέp`
&classinout; # XUiXέp

# move text-file to web-dir
system("mv $tmpdir/* $textdir");

##############################################################################
#
# subroutines begin here:
#
##############################################################################

#
# list top N for check virus
#
sub htmloutput {
   my($net) = "TANet";
   foreach $service ("total","icmp","ftp-data","ftp","telnet","smtp","dns","http","pop3","nntp","ntp","smb","imap","nnsp","https","squid-proxy","squid-icp","icq","others") {
      &topn_html($net,$service,"IN","DST","IP");
      &topn_html($net,$service,"OUT","SRC","IP");
      foreach $io ("IN", "OUT") {
         foreach $sd ("SRC", "DST") {
            &topn_html($net,$service,$io,$sd,"CLASSC");
         }
      }
   } 
}

sub topn_html {
   my($net,$service,$io,$sd,$type) = @_;
   my($file) = sprintf ("%s/%s-%s-%s-%s-%s.html",$htmldir,$net,$service,$io,$sd,$type);
   my $fh = new FileHandle("$tmpdir/$service-$io-$sd-$type.report");
   my ($line,@lines) = ("",());

   chomp($line = <$fh>); 
   chomp($line = <$fh>);
   my ($alli,$allflow,$allsize,$allpkts,$alldurn) = split (m"\,", $line);
   ${$net.$io.$service.ALL.FLOW} = $allflow;
   ${$net.$io.$service.ALL.SIZE} = $allsize;
   ${$net.$io.$service.ALL.PKTS} = $allpkts;
   chomp($line = <$fh>);
   chomp(@lines = <$fh>);
   my($num)=scalar(@lines);
   my($nummax)=$TopN;

   if ( $nummax > $num ) {
      $nummax = $num;
   } 

   if ($io eq "IN") {
      $description = sprintf("%s ==> school", $net);
   } else {   
      $description = sprintf("school ==> %s", $net);
   }
   
   if ($sd eq "SRC") {
      my($iptitle) = "Source";
   } else {
      my($iptitle) = "Destination";
   }
   
   open FILE, ">$file" or die $!;
   printf FILE ("<html>\n<body bgcolor=\"#ffffff\">\n");
   printf FILE ("<title>%4.4d-%2.2d-%2.2d Statistics of %s Traffic</title>\n", $nyear, $mon, $mday, $service);
   print FILE "<center>\n";
   printf FILE ("%4.4d-%2.2d-%2.2d Statistics of <font color=red>%s</font> Traffic\n", $nyear, $mon, $mday, $service);
   printf FILE ("<br>\n");

   print FILE "<table border=2 width=90%>\n";
   print FILE "<tr bgcolor=lightgreen>";
   if ((($io eq "OUT") && ($sd eq "SRC")) || (($io eq "IN") && ($sd eq "DST"))) {
      print FILE "<td align=right>ǮզW</td>";
   }
   print FILE "<td align=right>$iptitle</td><td align=right>Flows</td><td align=right>%</td><td align=right>KPackets</td><td align=right>%</td><td align=right>MBytes</td><td align=right>%</td></tr>\n";
   print FILE "<tr bgcolor=lightyellow>";
   if ((($io eq "OUT") && ($sd eq "SRC")) || (($io eq "IN") && ($sd eq "DST"))) {
      print FILE "<td align=right></td>";
   }
   printf FILE ("<td align=right>%s</td><td align=right>%11d</td><td align=right>%7.3f%%</td><td align=right> %11.3f</td><td align=right>%7.3f%%</td><td align=right> %11.3f</td><td align=right>%7.3f%%</td></tr>\n",$description,$allflow,$allflow/${$net.$io.total.ALL.FLOW}*100,$allpkts/1000,$allpkts/${$net.$io.total.ALL.PKTS}*1000,$allsize/(1024*1024),$allsize/${$net.$io.total.ALL.SIZE}*100);

   for ($i=0; $i<$nummax; $i++) {
      my($ip,$flow,$size,$pkts,$dur) = split (m"\,", $lines[$i]);
      if ($type eq "CLASSC") {
         $ip =~ s/\/24/\.0/;
         if ( $ip =~ m/^[0-9]*.[0-9]*.[0-9]*\/27/ ) { $ip =~ s/\/27/\.0/; }
         $ip =~ s/\/27//;
         if ( $ip =~ m/^[0-9]*.[0-9]*.[0-9]*\/28/ ) { $ip =~ s/\/28/\.0/; }
         $ip =~ s/\/28//;
      }
      if ((($io eq "OUT") && ($sd eq "SRC")) || (($io eq "IN") && ($sd eq "DST"))) {
	 printf FILE ("<td align=right>%s</td>",getschoolbyip($ip));
      }
      printf FILE ("<td align=right>%s</td><td align=right>%11d</td><td align=right>%7.3f%%</td><td align=right> %11.3f</td><td align=right>%7.3f%%</td><td align=right> %11.3f</td><td align=right>%7.3f%%</td></tr>\n",$ip,$flow,$flow/$allflow*100,$pkts/1000,$pkts/$allpkts*100,$size/(1024*1024),$size/$allsize*100);
   }
   print FILE "</table>\n";
   print FILE "</html>\n";
   close FILE;
}

# output daily summary
sub sumoutput {
   my($net)="TANet";
   my($file)=sprintf ("%s/summary-%s.html",$htmldir,$net);

   open FILE, ">$file" or die $!;
   printf FILE ("<html>\n<body bgcolor=\"#ffffff\">\n");
   printf FILE ("<title>%4.4d-%2.2d-%2.2d %s Statistics</title>\n", $nyear, $mon, $mday, $net);
   print FILE "<center>\n";
   printf FILE ("%4.4d-%2.2d-%2.2d %s Traffic Statistics\n", $nyear, $mon, $mday, $net);
   printf FILE ("<br>\n");
   
   print FILE "<table border=2 width=80%>\n";
   print FILE "<tr bgcolor=lightgreen><td align=right>Direction</td><td align=right>Flows</td><td align=right>KPackets</td><td align=right>MBytes</td></tr>\n";
   foreach $io ("IN", "OUT") {
      if ($io eq "IN") {
         $description = sprintf("%s ==> school", $net);
      }
      else {
         $description = sprintf("school ==> %s", $net);
      }
      printf FILE ("<tr><td align=right bgcolor=lightyellow>%s<td align=right>%11d<td align=right>%11.3f<td align=right>%11.3f</tr>\n",
      $description,
      ${$net.$io.total.ALL.FLOW},
      ${$net.$io.total.ALL.PKTS}/1000,
      ${$net.$io.total.ALL.SIZE}/(1024*1024));
   }
   print FILE "</table>\n";

   foreach $io ("IN", "OUT") {
      if ($io eq "IN") {
         $description = sprintf("%s ==> school", $net);
      }
      else {
         $description = sprintf("school ==> %s", $net);
      }

      my(%SUM)=();
      foreach $service ("total","icmp","ftp-data","ftp","telnet","smtp","dns","http","pop3","nntp","ntp","smb","imap","nnsp","https","squid-proxy","squid-icp","icq","others") {
         if (${$net.$io.$service.ALL.SIZE}) {
            $SUM{$service} = ${$net.$io.$service.ALL.SIZE};
         }
      }
      my (@sorted) = ( sort { $SUM{$b} <=> $SUM{$a} } keys %SUM );

      print FILE "<br>\n";
      print FILE "<table border=2 width=80%>\n";
      print FILE "<caption><font color=red>$description</font> Traffic</caption>\n";
      print FILE "<tr bgcolor=lightgreen><td align=right>Application</td><td align=right>Flows</td><td align=right>%</td><td align=right>KPackets</td><td align=right>%</td><td align=right>MBytes</td><td align=right>%</td></tr>\n";
      for ($i=0; $i<20; $i++) {
         if (${$net.$io.$sorted[$i].ALL.SIZE}) {
            printf FILE ("<tr><td align=right bgcolor=lightyellow>%s</td><td align=right>%11d</td><td align=right>%7.3f%%</td><td align=right> %11.3f</td><td align=right>%7.3f%%</td><td align=right> %11.3f</td><td align=right>%7.3f%%</td></tr>\n",
            $sorted[$i],
            ${$net.$io.$sorted[$i].ALL.FLOW},
            ${$net.$io.$sorted[$i].ALL.FLOW}/${$net.$io.total.ALL.FLOW}*100,
            ${$net.$io.$sorted[$i].ALL.PKTS}/1000,
            ${$net.$io.$sorted[$i].ALL.PKTS}/${$net.$io.total.ALL.PKTS}*100,
            ${$net.$io.$sorted[$i].ALL.SIZE}/(1024*1024),
            ${$net.$io.$sorted[$i].ALL.SIZE}/${$net.$io.total.ALL.SIZE}*100);
         }
      }
      print FILE "</table>\n";
   }
   print FILE "</html>\n";
   close FILE;
}

# output input & output static by classC
sub classinout {
   my($net)="TANet";
   my($type)="CLASSC";

   foreach $service ("total","icmp","ftp-data","ftp","telnet","smtp","dns","http","pop3","nntp","ntp","smb","imap","nnsp","https","squid-proxy","squid-icp","icq","others") {
      &classcstatic($net,$service,"IN","DST",$type);
      &classcstatic($net,$service,"OUT","SRC",$type);
   }

   @uip = sort(@uip);
   my($nummax) = scalar(@uip);

   foreach $io ("IN","OUT") {
      if ($io eq "IN") { $sd = "DST"; } else { $sd = "SRC"; }
      my($file)=sprintf ("%s/%s-%s-%s.html",$htmldir,$type,$net,$io);
      open FILE, ">$file" or die $!;
      printf FILE ("<html>\n<body bgcolor=\"#ffffff\">\n");
      printf FILE ("<title>%4.4d-%2.2d-%2.2d %s Statistics of CLASSC %s Traffic</title>\n", $nyear, $mon, $mday, $net, $io);
      print FILE "<center>\n";
      printf FILE ("%4.4d-%2.2d-%2.2d %s Statistics of <font color=red>CLASSC %s</font> Traffic\n", $nyear, $mon, $mday, $net, $io); 
      printf FILE ("<br>\n");
      print FILE "<table border=2 width=80%>\n";
      printf FILE ("<tr bgcolor=red><td bgcolor=lightgreen align=right>%5s %8s </td><td align=right>ALL(MB)</td><td align=right>ALL%%</td><td align=right>www%%</td><td align=right>ftp%%</td><td align=right>telnet%%</td><td align=right>mail%%</td><td align=right>dns%%</td><td align=right>proxy%%</td><td align=right>others%%</td></tr>\n", $net, $io);
      for ($i=0; $i<$nummax; $i++) {
         if (${$net.$io.$uip[$i].total.SIZE}) {
            foreach $service ("total","http","ftp","telnet","smtp","dns","squid-proxy","others") {
               my($perc) = ${$net.$io.$uip[$i].$service.SIZE}/${$net.$io.total.ALL.SIZE}*100;
               if ($service eq "total") {
                  printf FILE ("<tr bgcolor=lightblue><td bgcolor=pink align=right> %12s</td><td align=right> %8.2f</td><td align=right> %6.2f%%</td>", $uip[$i], ${$net.$io.$uip[$i].$service.SIZE}/(1024*1024), $perc);
               } else {
                  printf FILE ("<td align=right> %6.2f%%</td>", $perc);
               }
            }
         print FILE "</tr>\n";
         }
      }
      print FILE "</table>\n";
      print FILE "</html>\n";
      close FILE;
   }
}

sub classcstatic {
   my($net,$service,$io,$sd,$type) = @_;
   my($file)=sprintf ("%s/%s-%s-%s.html",$htmldir,$type,$net,$io);
   my $fh = new FileHandle("$tmpdir/$service-$io-$sd-$type.report");
   my ($line,@lines) = ("",());

   chomp($line = <$fh>);
   chomp($line = <$fh>);
   chomp($line = <$fh>);
   chomp(@lines = <$fh>);
   my($num)=scalar(@lines);
   for ($i=0; $i<$num; $i++) {
      my($ip,$flow,$size,$pkts,$dur) = split (m"\,", $lines[$i]);
      if ($flow > 20) {
         if ($type eq "CLASSC") {
            $ip =~ s/\/24/\.0/;
            if ( $ip =~ m/^[0-9]*.[0-9]*.[0-9]*\/27/ ) { $ip =~ s/\/27/\.0/; }
            $ip =~ s/\/27//;
            if ( $ip =~ m/^[0-9]*.[0-9]*.[0-9]*\/28/ ) { $ip =~ s/\/28/\.0/; }
            $ip =~ s/\/28//;
            if ($service eq "total") { $uip[$i] = $ip; }
         }
         ${$net.$io.$ip.$service.SIZE} = $size;
      }
   }
}
